let arr = [
    [14,10,10,12,13, 8,11,10, 4, 7, 3, 1],
    [10, 1,12, 7,13,13,12, 5, 8, 2, 0,13],
    [ 5, 1, 6,10, 4, 3, 3, 1, 9, 9, 3, 0],
    [11,13,13,14, 0, 5, 3, 2, 6,11, 9, 0],
    [14, 8, 6, 8, 6, 5, 9,10, 4,12,10, 6],
    [ 4,11, 6, 4, 3, 1,12,12, 6, 9, 6,14],
    [13,11, 0, 3, 3, 0, 4,12,12,10, 2, 0]
];

let w = 140,
    h =  60,
    H = arr.length*h + 20;

let fill = v =>
    (c=>c.copy({l:1-(1-c.l)/2}))
        (d3.hsl(d3.interpolatePlasma((3+v)/18)));

function drawRows(elt, opacity) {
    let r = elt.append('g').attr('text-anchor','end').attr('opacity',opacity)
        .selectAll().data(arr).enter()
        .append('g').attr('transform',(_,i)=>'translate(0,'+h*i+')');
    let d = r.selectAll().data(n=>n).enter()
        .append('g').attr('transform',(_,j)=>'translate('+w*j+',0)');
    d.append('rect')
        .attrs({ 'stroke-width':1, stroke:'black', fill:fill,
                 x:0, y:0, width:w, height:h });
    d.append('text')
        .attrs({x:w-10, y:h/2+16, 'font-size':50})
        .text(v=>v);
    return r;
}

let svg = d3.select('svg.center').append('g').attr('transform','translate(100,10)');
svg.append('text')
    .attrs({
        x:-24,'text-anchor':'end',
        y:H+h/2,dy:'0.38em',
        'font-family':'monospace', 'font-size':44
    })
    .html('<tspan class="Type">⌈</tspan><tspan class="PreProc">/</tspan>')
drawRows(svg, 0.4);
let rows = drawRows(svg, null),
    last = rows.size(),
    result = null,
    diff = null;

document.onclick = function () {
    if (!last) return;
    last--;
    let next = rows.filter((_,i)=>i===last);
    next.transition().duration(700)
        .attr('transform','translate(0,'+H+')');
    if (!result) {
        result = next.selectAll('g');
        diff = result.data();
    } else {
        let r = next.selectAll('g').data();
        diff = diff.map((d,i) => Math.max(r[i],d));
        result.data(diff).transition().delay(200).select('text').text(v=>v);
        result.select('rect').transition().duration(700).attr('fill',fill);
    }
}
